.386
.model flat, stdcall  ; 32 bit memory model
option casemap :none  ; case sensitive

.code 

start:



_secret         equ 013B0000h       ; beginning of area where encrypted tables are stored
_secret_end     equ 01421FF8h       ; end of zone in memory where encrypted tables are stored
_rdata          equ 008EA000h       ; beginning of .rdata, where all the tables SHOULD be stored
_rdata_end      equ 009C6FF8h       ; end of section where all tables should be stored
_stxt774        equ 00A79000h       ; beginning of stxt774


mov eax, _rdata

_find_table_loop:

cmp dword ptr[eax], 067231341h		; is it a table?
je _rdata_found				; if so, jump

_find_table_loop_ok:

inc eax					; increase pointer
cmp eax, _rdata_end			; are we at the end?
jle _find_table_loop			; if not, keep going

int 3					; int3 tells us we are done

_rdata_found:

mov edx, eax				; take location of stolen tables
add edx, 050h				; increase pointer by 50 and get ready to look for dword to encrypted table

_find_secret_loop:

cmp byte ptr[edx], 0			; have we found something
jne _found_secret			; if so, jump
inc edx					; else increase pointer
jmp _find_secret_loop			; and continue loop

_found_secret:

mov edx, dword ptr[edx]			; take the offset of the encrypted table
mov ecx, edx				; put it in ecx

xor ebp, ebp				; use ebp as counter >.<


_copyloop:

mov edx, dword ptr[ecx]             ; put the dword in edx
mov dword ptr[eax], edx             ; and deposit it in the other table
inc ebp                             ; increase the counter
add eax, 4
add ecx, 4                          ; increase the position pointers
cmp ebp, 0Eh                        ; see of we have copied all the dwords in the table
jne _copyloop                       ; if we haven't, keep on copying

add ecx, 010h                       ; move the pointer up so it goes over the table
sub eax, 024h                       ; and move this pointer down so that it is at the first encrypted dword

mov dword ptr[eax], 05CAC5AC5h      ; put the default dword here
add eax, 4                          ; and move the pointer up



_find_xor_table_loop:

cmp byte ptr[ecx], 00h              ; did we reach the table yet?
jne _decrypt_with_xor               ; if we did, lets decrypt

inc ecx                             ; move the pointer up 
jmp _find_xor_table_loop            ; and continue looking for the xor table 

_decrypt_with_xor:

xor ebp, ebp                        ; using EBP as a counter

_decrypt_loop:

mov edx, dword ptr[ecx]             ; take the first decrypt key
xor dword ptr[eax], edx             ; decrypt a dword
add ecx, 4
add eax, 4                          ; move the pointers up
inc ebp                             ; increase the counter
cmp ebp, 8                          ; did we decrypt it all?
jne _decrypt_loop                   ; if we didn't keep on going

jmp _find_table_loop                  ; well, its all done. lets get on with decrypting the next table =).


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


_2nd_part:

pushad
pushfd
mov eax, _rdata

_loop_rwdata_for_2nd_table:

cmp eax, dword ptr[eax+4]		; look for that special pattern
je _found_2nd_table			; if we find it, start grabbing all the vales we need to find its 'encrypted' form in memory

_2nd_loop_nope:

inc eax					; increase the pointer by one
cmp eax, _stxt774			; check if we have searched all of the programs data
jne _loop_rwdata_for_2nd_table		; if we haven't, continue working

jmp _2nd_end				; if we have, end this

_found_2nd_table:

mov edx, dword ptr[eax]			; take the first value we need for ID
mov ebx, eax				; put the pointer in ebx
sub ebx, 050h				; sub ebx by 50h to get the offset of the second value we need for ID
mov ebx, dword ptr[ebx]			; get the value, and put it in ebx


mov edi, _secret			; prepare to start searching the memory

_search_secret_for_2nd_table:

cmp dword ptr[edi], edx			; have we found one of the ID values?
je _found_2nd_in_mem			; if so, jump to the other check

_2nd_secret_search_nope:

inc edi					; else just increase pointer by 1
jmp _search_secret_for_2nd_table	; and continue the loop

_found_2nd_in_mem:

mov ecx, edi				; put the pointer of the first ID 
sub ecx, 010h				; subtract 10h from it to get the supposed pointer of the second ID

cmp dword ptr[ecx], ebx			; check if everything is in order
jne _2nd_secret_search_nope		; if not, continue looking

sub ecx, 4				; subtract 4 from here to get the beginning of the values
xor ebp, ebp				; null out ebp for later use
sub eax, 05Ch				; SUB from EAX 5Ch to get where the real decrypted/pasted table should start

mov dword ptr[eax], 03F465457h		; Put the special tag
add eax, 8				; move pointer up to area where values should be copied

_2nd_copy_loop:
		
mov edx, dword ptr[ecx]			; take the value from the memory
mov dword ptr[eax], edx			; write it into the area in the exe
add eax, 4				; move pointer up to next dword
add ecx, 4				; move pointer up to next dword
inc ebp					; incrase the counter
cmp ebp, 0Bh				; have we copied the needed amount (11) dwords?
jne _2nd_copy_loop			; if not, continue loop

xor ebp, ebp				; null out counter (we'll be needing it again)
mov dword ptr[eax-010h], 00h		; and null out the stupid FFFFFFFF

_2nd_fill_loop:

inc ebp					; incrase the counter
mov dword ptr[eax], ebp			; write the counter(these values are always 0-8)
add eax, 4				; move the pointer in the exe up
cmp ebp, 8				; have we gone up to 8?
jne _2nd_fill_loop			; if not, continue loop

add eax, 4				; move up pointer (there is 00h always after the 8)
mov dword ptr[eax], 073872468h		; put the default hash as the last hash at the end of the table

add eax, 010h				; mov the pointer in the exe up, and prepare to search another part of the exe
jmp _2nd_loop_nope			; continue the search

_2nd_end:

popfd					; restore the registers (out of habit, dont shoot me. I know its stupid)
popad 
int 3					; int 3 will make the debugger break, and we will know that the decryption has been finished





end start
